apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: {{ include "hlf-peer.fullname" . }}
  namespace: {{ .Release.Namespace }}
  labels:
    {{- include "hlf-peer.labels" . | nindent 4 }}
    app.kubernetes.io/component: peer
  annotations:
    reloader.stakater.com/auto: "true"
spec:
  serviceName: {{ include "hlf-peer.fullname" . }}
  selector:
    matchLabels:
      {{- include "hlf-peer.selectorLabels" . | nindent 6 }}
      app.kubernetes.io/component: peer
  template:
    metadata:
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "hlf-peer.selectorLabels" . | nindent 8 }}
        {{- with .Values.podLabels }}
        {{- toYaml . | nindent 8 }}
        {{- end }}
        hlf-peer-msp-id: {{ .Values.peer.mspID | quote }}
        app.kubernetes.io/component: peer
        {{ include "hlf-peer.fullname" . }}-couchdb-client: "true"
    spec:
      {{- with .Values.image.pullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "hlf-peer.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      # load the external chaincode builder into the peer image prior to peer launch.
      initContainers:
        - name: helper
          image: registry.gitlab.com/xdev-tech/xdev-enterprise-business-network/hlf-k8s/helper:{{ $.Chart.Version }}
          imagePullPolicy: IfNotPresent
          command: [sh, -c]
          args:
            - |-
              mkdir -p /var/hyperledger/fabric/chaincode/k8s-helper/bin/
              cp /go/bin/* /var/hyperledger/fabric/chaincode/k8s-helper/bin/
          volumeMounts:
            - name: k8s-helper
              mountPath: /var/hyperledger/fabric/chaincode/k8s-helper
        # load the chaincode id calculator into the peer image prior to peer launch.
        - name: ccid
          image: registry.gitlab.com/xdev-tech/xdev-enterprise-business-network/hlf-k8s/ccid:{{ $.Chart.Version }}
          imagePullPolicy: IfNotPresent
          command: [sh, -c]
          args: ["cp /ccid /var/hyperledger/fabric/chaincode/ccid/bin"]
          volumeMounts:
            - name: ccid
              mountPath: /var/hyperledger/fabric/chaincode/ccid/bin
      volumes:
        - name: k8s-helper
          emptyDir: {}
        - name: ccid
          emptyDir: {}
        {{- if .Values.secrets.peer.cert }}
        - name: id-cert
          secret:
            secretName: {{ .Values.secrets.peer.cert }}
        {{- end }}
        {{- if .Values.secrets.peer.key }}
        - name: id-key
          secret:
            secretName: {{ .Values.secrets.peer.key }}
        {{- end }}
        {{- if .Values.secrets.peer.caCert }}
        - name: cacert
          secret:
            secretName: {{ .Values.secrets.peer.caCert }}
        {{- end }}
        {{- if .Values.secrets.peer.intCaCert }}
        - name: intcacert
          secret:
            secretName: {{ .Values.secrets.peer.intCaCert }}
        {{- end }}
        {{- if .Values.secrets.peer.tls }}
        - name: tls
          secret:
            secretName: {{ .Values.secrets.peer.tls }}
        {{- end }}
        {{- if .Values.secrets.peer.tlsRootCert }}
        - name: tls-rootcert
          secret:
            secretName: {{ .Values.secrets.peer.tlsRootCert }}
        {{- end }}
        {{- if .Values.secrets.peer.tlsClient }}
        - name: tls-client
          secret:
            secretName: {{ .Values.secrets.peer.tlsClient }}
        {{- end }}
        {{- if .Values.secrets.peer.tlsClientRootCert }}
        - name: tls-clientrootcert
          secret:
            secretName: {{ .Values.secrets.peer.tlsClientRootCert }}
        {{- end }}
        {{- if .Values.secrets.channels }}
          {{- range $channel := .Values.secrets.channels }}
        - name: {{ $channel.name }}
          secret:
            secretName: {{ $channel.secretName }}
          {{- end }}
        {{- end }}
        {{- if .Values.secrets.adminCert }}
        - name: admin-cert
          secret:
            secretName: {{ .Values.secrets.adminCert }}
        {{- end }}
        {{- if .Values.secrets.adminKey }}
        - name: admin-key
          secret:
            secretName: {{ .Values.secrets.adminKey }}
        {{- end }}
        {{- if .Values.secrets.ordTlsRootCert }}
        - name: ord-tls-rootcert
          secret:
            secretName: {{ .Values.secrets.ordTlsRootCert }}
        {{- end }}
        - name: builders-config
          configMap:
            name: {{ include "hlf-peer.fullname" . }}-builders-config
            items:
              - key: core.yaml
                path: core.yaml
        # - name: external-builder-detect
        #   configMap:
        #     name: {{ include "hlf-peer.fullname" . }}-builders-config
        #     items:
        #       - key: detect
        #         path: detect
        #         mode: 0544
        # - name: external-builder-build
        #   configMap:
        #     name: {{ include "hlf-peer.fullname" . }}-builders-config
        #     items:
        #       - key: build
        #         path: build
        #         mode: 0544
        # - name: external-builder-release
        #   configMap:
        #     name: {{ include "hlf-peer.fullname" . }}-builders-config
        #     items:
        #       - key: release
        #         path: release
        #         mode: 0544

      containers:
        - name: peer
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: request
              containerPort: 7051
              protocol: TCP
            - name: event
              containerPort: 7053
              protocol: TCP
            {{- if eq .Values.peer.metrics.provider "prometheus" }}
            - name: metrics
              containerPort: 9443
              protocol: TCP
            {{- end }}
          livenessProbe:
            exec:
              command:
                - ls
                - /var/hyperledger
          # TODO: Improve readiness probe (ideally `ps aux | awk '$11=="orderer"'`)
          readinessProbe:
            exec:
              command:
                - ls
                - /var/hyperledger
          command:
            - sh
            - -c
            - |
              # To avoid having separate secrets for CouchDB and HLF
              export CORE_LEDGER_STATE_COUCHDBCONFIG_USERNAME=$COUCHDB_USER
              export CORE_LEDGER_STATE_COUCHDBCONFIG_PASSWORD=$COUCHDB_PASSWORD

              while [ ! -d /var/hyperledger/admin_msp/admincerts ] || [ -z "$(ls -A /var/hyperledger/admin_msp/admincerts)" ];
              do
                echo -e "\033[0;31m /var/hyperledger/admin_msp/admincerts must contain Peer admin certificates files \033[0m"
                sleep 60
              done

              while [ ! -d ${CORE_PEER_MSPCONFIGPATH}/signcerts ];
              do
                echo -e "\033[0;31m ${CORE_PEER_MSPCONFIGPATH}/signcerts directory must exist \033[0m"
                sleep 60
              done

              if [ ! -d ${FABRIC_CFG_PATH} ]
              then
                mkdir -p ${FABRIC_CFG_PATH}
                cp -r /etc/hyperledger/fabric/core.yaml ${FABRIC_CFG_PATH}
                ls ${FABRIC_CFG_PATH}
              fi

              if [ $CORE_PEER_TLS_CLIENTAUTHREQUIRED ]
              then
                export CORE_PEER_TLS_CLIENTROOTCAS_FILES=$(ls -d $CORE_PEER_TLS_CLIENTROOTCAS_FILES)
              fi

              echo "{{ include "hlf-peer.fullname" $ }}-" > /var/hyperledger/fabric/chaincode/k8s-helper/base-address

              echo -e ">\033[0;35m peer node start \033[0m"
              exec peer node start
          envFrom:
            - configMapRef:
                name: {{ include "hlf-peer.fullname" . }}
            {{- if .Values.couchdb.enabled }}
            - secretRef:
                name: {{ include "hlf-peer.fullname" . }}-couchdb
            {{- end }}
          volumeMounts:
            - mountPath: /var/hyperledger
              name: data
            {{- if .Values.peer.docker.enabled }}
            - mountPath: /host/var/run/docker.sock
              name: dockersocket
            {{- if .Values.docker.config }}
            - name: docker-config
              mountPath: {{ .Values.docker.configMountPath }}
            {{- end }}
            {{- end }}
            {{- if .Values.secrets.peer.cert }}
            - mountPath: /var/hyperledger/msp/signcerts
              name: id-cert
            {{- end }}
            {{- if .Values.secrets.peer.key }}
            - mountPath: /var/hyperledger/msp/keystore
              name: id-key
            {{- end }}
            {{- if .Values.secrets.peer.caCert }}
            - mountPath: /var/hyperledger/msp/cacerts
              name: cacert
            - mountPath: /var/hyperledger/admin_msp/cacerts
              name: cacert
            {{- end }}
            {{- if .Values.secrets.peer.intCaCert }}
            - mountPath: /var/hyperledger/msp/intermediatecerts
              name: intcacert
            - mountPath: /var/hyperledger/admin_msp/intermediatecerts
              name: intcacert
            {{- end }}
            {{- if .Values.secrets.peer.tls }}
            - mountPath: /var/hyperledger/tls/server/pair
              name: tls
            {{- end }}
            {{- if .Values.secrets.peer.tlsRootCert }}
            - mountPath: /var/hyperledger/tls/server/cert
              name: tls-rootcert
            {{- end }}
            {{- if .Values.secrets.peer.tlsClient }}
            - mountPath: /var/hyperledger/tls/client/pair
              name: tls-client
            {{- end }}
            {{- if .Values.secrets.peer.tlsClientRootCert }}
            - mountPath: /var/hyperledger/tls/client/cert
              name: tls-clientrootcert
            {{- end }}
            {{- if .Values.secrets.ordTlsRootCert }}
            - mountPath: /var/hyperledger/tls/ord/cert
              name: ord-tls-rootcert
            {{- end }}
            {{- if .Values.secrets.channels }}
              {{- range $channel := .Values.secrets.channels }}
            - mountPath: /hl_config/channel/{{ $channel.secretName }}
              name: {{ $channel.name }}
              {{- end }}
            {{- end }}
            {{- if .Values.secrets.adminCert }}
            - mountPath: /var/hyperledger/admin_msp/admincerts
              name: admin-cert
            - mountPath: /var/hyperledger/admin_msp/signcerts
              name: admin-cert
            - mountPath: /var/hyperledger/msp/admincerts
              name: admin-cert
            {{- end }}
            {{- if .Values.secrets.adminKey }}
            - mountPath: /var/hyperledger/admin_msp/keystore
              name: admin-key
            {{- end }}
            - mountPath: /var/hyperledger/fabric_cfg/core.yaml
              name: builders-config
              subPath: core.yaml
            # - mountPath: /builders/external/bin/detect
            #   name: external-builder-detect
            #   subPath: detect
            # - mountPath: /builders/external/bin/build
            #   name: external-builder-build
            #   subPath: build
            # - mountPath: /builders/external/bin/release
            #   name: external-builder-release
            #   subPath: release
            - name: k8s-helper
              mountPath: /var/hyperledger/fabric/chaincode/k8s-helper
            - name: ccid
              mountPath: /var/hyperledger/fabric/chaincode/ccid/bin
          resources:
{{ toYaml .Values.resources | indent 12 }}
    {{- with .Values.nodeSelector }}
      nodeSelector:
{{ toYaml . | indent 8 }}
    {{- end }}
    {{- with .Values.affinity }}
      affinity: 
{{ toYaml . | indent 8 }}
    {{- end }}

    {{- with .Values.tolerations }}
      tolerations:
{{ toYaml . | indent 8 }}
    {{- end }}
  volumeClaimTemplates:
    - metadata:
        name: data
      spec:
        accessModes:
          - {{ .Values.persistence.accessMode | quote }}
        resources:
          requests:
            storage: {{ .Values.persistence.size | quote }}
        {{- if .Values.persistence.storageClass }}
        storageClassName: {{ .Values.persistence.storageClass }}
        {{- end }}
